=== debian/changelog ===
ddnet (14.1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jul 2020 15:04:07 +0200

ddnet (14.1-1) unstable; urgency=medium

  * New upstream release
  * Bump debhelper compat to 13

 -- Yangfl <mmyangfl@gmail.com>  Wed, 01 Jul 2020 12:29:20 +0800

ddnet (13.0.1-1ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Apr 2020 15:38:40 +0200

ddnet (13.0.1-1) unstable; urgency=medium

  * New upstream release
  * Remove buggy websockets support
  * Add build dep libjsonparser-dev and add use-system-libjsonparser.patch

 -- Yangfl <mmyangfl@gmail.com>  Fri, 10 Apr 2020 10:32:55 +0800
