=== debian/control ===
Source: ddnet
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 SZ Lin (林上智) <szlin@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 cmake,
 python3,
 libcurl4-openssl-dev,
 libfreetype6-dev,
 libogg-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev,
 libmariadb-dev,
 libmysqlcppconn-dev,
 libboost-dev,
 libglew-dev,
 libpnglite-dev,
 libwavpack-dev,
 libjsonparser-dev,
 libgtest-dev,
 libnotify-dev,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://ddnet.tw/
Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
Vcs-Browser: https://salsa.debian.org/games-team/ddnet

Package: ddnet
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Description: Teeworlds modification with a unique cooperative gameplay
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the client binary for DDNet.

Package: ddnet-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (>= ${source:Version}),
Suggests:
 ddnet-tools,
Description: Server for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the server binary for DDNet.

Package: ddnet-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Tools for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains tools for DDNet maps and configs.

Package: ddnet-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 fonts-dejavu-core,
Recommends:
 fonts-wqy-microhei,
Description: Data for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the static data for DDNet.
