=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
  libjsonparser-dev,
  libgtest-dev,
  libnotify-dev,
+ libsqlite3-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://ddnet.tw/
@@ -81,7 +82,7 @@
  ${misc:Depends},
  fonts-dejavu-core,
 Recommends:
- fonts-wqy-microhei,
+ fonts-noto-cjk,
 Description: Data for DDNet
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
