=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,6 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
-ifeq ($(DEB_HOST_ARCH),s390x)
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
-endif
 
 %:
 	dh $@
@@ -26,7 +23,7 @@
 	# pass
 
 execute_after_dh_auto_clean-indep:
-	$(RM) -r datasrc/*.pyc datasrc/__pycache__
+	$(RM) -r datasrc/__pycache__ datasrc/seven/__pycache__
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
@@ -48,6 +45,6 @@
 	done;
 
 execute_after_dh_install-indep:
-	for f in languages/license.txt; do \
-		rm -r "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
+	for f in languages/license.txt maps/license.txt skins/license.txt; do \
+		$(RM) "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done
