=== debian/changelog ===
ddnet (15.3.2-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 28 Feb 2021 09:30:45 +0100

ddnet (15.3.2-1) unstable; urgency=medium

  * New upstream release
    + Fix FTBFS on riscv64 (Closes: #978632)
  * Bump Standards-Version to 4.5.1

 -- Yangfl <mmyangfl@gmail.com>  Sun, 21 Feb 2021 22:46:10 +0800

ddnet (15.1.3-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Lower optimization level on s390x to fix a build failure
    - allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Oct 2020 08:46:01 +0100
