=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,9 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
+ifeq ($(DEB_HOST_ARCH),s390x)
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
+endif
 
 %:
 	dh $@
@@ -45,6 +48,6 @@
 	done;
 
 execute_after_dh_install-indep:
-	for f in languages/license.txt maps/license.txt skins/license.txt; do \
+	for f in assets/entities/license.txt languages/license.txt maps/license.txt skins/license.txt; do \
 		$(RM) "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done
