=== debian/changelog ===
ddnet (15.5.4-1ubuntu1) impish; urgency=medium

  * Allow stderr to make warnings not fatal in autopkgtests on armhf and
    ppc64el (see: #995742)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Oct 2021 17:55:37 +0200

ddnet (15.5.4-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0

 -- Yangfl <mmyangfl@gmail.com>  Thu, 30 Sep 2021 11:45:10 +0800
