=== debian/changelog ===
ddnet (15.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 22 Feb 2022 22:04:09 +0800

ddnet (15.8.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sat, 01 Jan 2022 14:31:29 +0800

ddnet (15.7-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Mon, 29 Nov 2021 06:47:41 +0800

ddnet (15.6.2-1) unstable; urgency=medium

  * New upstream release
  * Allow stderr in autopkgtest for gcc warnings (Closes: #995742)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 14 Nov 2021 03:59:51 +0800
