=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper-compat (= 13),
 Build-Depends-Arch:
  cmake,
- python3,
+ python3:native,
  libcurl4-openssl-dev,
  libfreetype6-dev,
  libogg-dev,
@@ -23,7 +23,8 @@
  libpnglite-dev,
  libwavpack-dev,
  libjsonparser-dev,
- libgtest-dev,
+ libgtest-dev <!nocheck>,
+ libgmock-dev <!nocheck>,
  libnotify-dev,
  libsqlite3-dev,
 Rules-Requires-Root: no
