=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,6 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
-ifeq ($(DEB_HOST_ARCH),s390x)
-  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
-endif
 
 %:
 	dh $@
