=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.xz%ddnet-$1.tar.xz%" \
   https://ddnet.tw/downloads/ \
   DDNet-(\d[\d.]*)\.tar\.xz debian uupdate
