=== debian/changelog ===
ddnet (16.0.2-1build1) kinetic; urgency=medium

  * No-change rebuild against libavcodec59

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 19 Jul 2022 12:46:14 +0000

ddnet (16.0.2-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Sun, 03 Apr 2022 14:30:49 +0800
