=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ddnet
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
@@ -27,6 +28,12 @@
  libgmock-dev <!nocheck>,
  libnotify-dev,
  libsqlite3-dev,
+ libvulkan-dev,
+ glslang-tools,
+ libx264-dev,
+ libavformat-dev,
+ libswresample-dev,
+ libswscale-dev,
 Rules-Requires-Root: no
 Standards-Version: 4.6.0
 Homepage: https://ddnet.tw/
